;-- TIME_STAMP   2020-06-13 01:44:01   v 0.1

#Region    ;************ Includes ************
#include-once
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
;~ #include <APISysConstants.au3>
#include <File.au3>
#include <GuiListView.au3>
#include <GuiStatusBar.au3>
;~ #include <WinAPIConv.au3>
#include <WinAPIMisc.au3>
#include "_WindowPlacement.au3"
#EndRegion ;************ Includes ************

Opt('GUIResizeMode', $GUI_DOCKAUTO)
Opt('MustDeclareVars', 1)

Global $g_hMainGUI, $g_hHeader, $g_hListView1, $g_hListView2, $g_hStatus
Global $g_hChildGUI, $g_hChildEdit, $g_hChildStatus
Global $g_iLVStyle = $LVS_SHOWSELALWAYS ; $GUI_SS_DEFAULT_LISTVIEW = BitOR($LVS_SHOWSELALWAYS, $LVS_SINGLESEL)
Global $g_iLVStyleEx = BitOR($WS_EX_CLIENTEDGE, $LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES, $LVS_EX_DOUBLEBUFFER, $LVS_EX_SUBITEMIMAGES)
Global $g_aWinPos = [-1, -1, 800, 480], $g_aClientSize[2]
Global $g_iMainGUIWidthMin = 343, $g_iMainGUIHeightMin = 512, $g_iAspectRatio = @DesktopWidth / @DesktopHeight
Global $g_sWindowIni = @ScriptDir & '\Window.Ini'
Global $g_sWindowPlacementIni = @ScriptDir & '\WindowPlacement.Ini'

Global $g_bPrimary = False
;~ True  : Fenster wird auf den primären Monitor verschoben, falls sich die linke obere Ecke in einem nicht sichtbaren Bereich befindet
;~ False : Fenster wird auf den ersten gefundenen sekundären Monitor verschoben, falls sich die linke obere Ecke in einem nicht sichtbaren Bereich befindet

MsgBox(64, @ScriptName, 'Veschiebe die Fenster so, dass die linke obere Ecke nicht mehr sichtbar ist.' & @CRLF & 'Beende das Script und starte es erneut - die linke obere Ecke ist wieder sichtbar!', 3)

_Main()

Func _Main()
	#Region - GUI Create
	$g_hMainGUI = GUICreate('MainGUI', $g_aWinPos[2], $g_aWinPos[3], $g_aWinPos[0], $g_aWinPos[1], BitOR($GUI_SS_DEFAULT_GUI, $WS_MAXIMIZEBOX, $WS_SIZEBOX), $WS_EX_WINDOWEDGE)
	Local $aPos = WinGetPos($g_hMainGUI)
	Local $aClientSize = WinGetClientSize($g_hMainGUI)
	Local $sWinPos = 'MainGUI|' & $aPos[0] & '|' & $aPos[1] & '|' & _ArrayToString($aClientSize, '|') & @CRLF
	ConsoleWrite("> GUICreate('MainGUI', 800, 480, -1, -1)" & @CRLF)
	ConsoleWrite('> $g_aWinPos   = ' & _ArrayToString($g_aWinPos, ', ') & @CRLF)
	ConsoleWrite('+  $g_hMainGUI: $aClientSize = ' & _ArrayToString($aClientSize, ', ') & @CRLF)
	ConsoleWrite('!  $g_hMainGUI: $aPos        = ' & _ArrayToString($aPos, ', ') & @CRLF)

	$g_hHeader = _GUICtrlHeader_Create($g_hMainGUI)
	_GUICtrlHeader_SetUnicodeFormat($g_hHeader, True)
	; Add columns
	_GUICtrlHeader_AddItem($g_hHeader, "Column 1", 100)
	_GUICtrlHeader_AddItem($g_hHeader, "Column 2", 100)
	_GUICtrlHeader_AddItem($g_hHeader, "Column 3", 100)
	_GUICtrlHeader_AddItem($g_hHeader, "Column 4", 100)
	_GUICtrlHeader_SetItemWidth($g_hHeader, 0, 200)
	_GUICtrlHeader_SetItemWidth($g_hHeader, 1, 200)
	_GUICtrlHeader_SetItemWidth($g_hHeader, 2, 200)
	_GUICtrlHeader_SetItemWidth($g_hHeader, 3, 200)

	Local $idMenu = GUICtrlCreateMenu("&File")
	Local $idExit = GUICtrlCreateMenuItem("E&xit", $idMenu)

	Local $idListView1 = GUICtrlCreateListView('Column 1|Column 2|Column 3|Column 4', 10, 30, 780, 160, $g_iLVStyle, $g_iLVStyleEx)
	Local $idListView2 = GUICtrlCreateListView('Column 1|Column 2|Column 3|Column 4', 10, 210, 780, 160, $g_iLVStyle, $g_iLVStyleEx)
	$g_hListView1 = GUICtrlGetHandle($idListView1)
	$g_hListView2 = GUICtrlGetHandle($idListView2)

	Local $idButton_1 = GUICtrlCreateButton('800 x ...', 10, 380, 253, 22)
;~ 	GUICtrlSetResizing(-1, $GUI_DOCKHEIGHT)
	Local $idButton_2 = GUICtrlCreateButton('1200 x ...', 273, 380, 253, 22)
;~ 	GUICtrlSetResizing(-1, $GUI_DOCKHEIGHT)
	Local $idButton_3 = GUICtrlCreateButton('1700 x ...', 536, 380, 253, 22)
;~ 	GUICtrlSetResizing(-1, $GUI_DOCKHEIGHT)
	Local $idButton_4 = GUICtrlCreateButton('Exit', 10, 410, 780, 22)
;~ 	GUICtrlSetResizing(-1, $GUI_DOCKHEIGHT)

	$g_hStatus = _GUICtrlStatusBar_Create($g_hMainGUI)
	GUISetState()
	_LoadWindowPlacement($g_sWindowPlacementIni, 'MainGUI', $g_hMainGUI)
	_CheckWinPos($g_hMainGUI, $g_bPrimary, 50)
	_GUICtrlStatusBar_Resize($g_hStatus)
;~ 	_WinAPI_RedrawWindow($g_hMainGUI)

	$g_hChildGUI = GUICreate('ChildGUI', $g_aWinPos[2], $g_aWinPos[3], $aPos[0] + 100, $aPos[1] + 100, BitOR($GUI_SS_DEFAULT_GUI, $WS_MAXIMIZEBOX, $WS_SIZEBOX), $WS_EX_WINDOWEDGE)
	$aPos = WinGetPos($g_hChildGUI)
	$aClientSize = WinGetClientSize($g_hChildGUI)
	ConsoleWrite('+ $g_hChildGUI: $aClientSize = ' & _ArrayToString($aClientSize, ', ') & @CRLF)
	ConsoleWrite('! $g_hChildGUI: $aPos        = ' & _ArrayToString($aPos, ', ') & @CRLF)
	$sWinPos &= 'ChildGUI|' & $aPos[0] & '|' & $aPos[1] & '|' & _ArrayToString($aClientSize, '|') & @CRLF
	Local $hFile = FileOpen($g_sWindowIni, $FO_OVERWRITE)
	Local $iWrite = FileWrite($hFile, $sWinPos) + FileClose($hFile) ? FileGetSize($g_sWindowIni) : -1
	If $iWrite < 1 Then
		ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : Error $hFile = ' & $hFile & ' $iWrite = ' & $iWrite & ' FileWrite('&$g_sWindowIni&')' & @CRLF)
		; Exit 1
	EndIf

	GUISetState()
	_LoadWindowPlacement($g_sWindowPlacementIni, 'ChildGUI', $g_hChildGUI)
	_CheckWinPos($g_hChildGUI, $g_bPrimary, 100)
;~ 	_WinAPI_RedrawWindow($g_hChildGUI)
	$g_hChildStatus = _GUICtrlStatusBar_Create($g_hChildGUI)
	#EndRegion - GUI Create

	; Sent to a window after its size has changed.
	; https://docs.microsoft.com/en-us/windows/win32/winmsg/wm-size
	GUIRegisterMsg($WM_SIZE, '_WM_SIZE')

	; Sent to a window when the size or position of the window is about to change.
	; An application can use this message to override the window's default maximized size and position, or its default minimum or maximum tracking size.
	; https://docs.microsoft.com/en-us/windows/win32/winmsg/wm-getminmaxinfo
	GUIRegisterMsg($WM_GETMINMAXINFO, '_WM_GETMINMAXINFO')

	; Posted when the user double-clicks the left mouse button while the cursor is within the nonclient area of a window.
	; This message is posted to the window that contains the cursor. If a window has captured the mouse, this message is not posted.
	; https://docs.microsoft.com/en-us/windows/win32/inputdev/wm-nclbuttondblclk
	GUIRegisterMsg($WM_NCLBUTTONDBLCLK, '_WM_NCLBUTTONDBLCLK')

	#Region - GUI SwitchLoop
	Local $aWinPos, $aClientSize
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $idButton_4
				_SaveWindowPlacement($g_sWindowPlacementIni, 'MainGUI', $g_hMainGUI)
				_SaveWindowPlacement($g_sWindowPlacementIni, 'ChildGUI', $g_hChildGUI)
				ConsoleWrite(FileRead($g_sWindowPlacementIni) & @CRLF)
				Exit
			Case $idButton_1
				$aWinPos = WinGetPos($g_hMainGUI)
				$aClientSize = WinGetClientSize($g_hMainGUI)
				$aWinPos[2] = $aWinPos[2] - $aClientSize[0] + 800
				Local $x = $aWinPos[2]
				$x -= $aClientSize[0] + 800
				ConsoleWrite($aWinPos[2] & @CRLF)
				ConsoleWrite($x & @CRLF)
				$aWinPos[3] = $aWinPos[3] - $aClientSize[1] + 800 / $g_iAspectRatio
				WinMove($g_hMainGUI, '', Default, Default, $aWinPos[2], $aWinPos[3])
			Case $idButton_2
				$aWinPos = WinGetPos($g_hMainGUI)
				$aClientSize = WinGetClientSize($g_hMainGUI)
				$aWinPos[2] = $aWinPos[2] - $aClientSize[0] + 1200
				$aWinPos[3] = $aWinPos[3] - $aClientSize[1] + 1200 / $g_iAspectRatio
				WinMove($g_hMainGUI, '', Default, Default, $aWinPos[2], $aWinPos[3])
			Case $idButton_3
				$aWinPos = WinGetPos($g_hMainGUI)
				$aClientSize = WinGetClientSize($g_hMainGUI)
				$aWinPos[2] = $aWinPos[2] - $aClientSize[0] + 1700
				$aWinPos[3] = $aWinPos[3] - $aClientSize[1] + 1700 / $g_iAspectRatio
				WinMove($g_hMainGUI, '', Default, Default, $aWinPos[2], $aWinPos[3])
		EndSwitch
	WEnd
	#EndRegion - GUI SwitchLoop
EndFunc   ;==>_Main

Func _WM_NCLBUTTONDBLCLK($hWnd, $iMsg, $wParam, $lParam)
	#forceref $iMsg, $wParam, $lParam
;~ 	ConsoleWrite('_WM_NCLBUTTONDBLCLK: $wParam = ' & $wParam & @CRLF)
	If $wParam = $HTBOTTOMRIGHT Then     ; (17) In the lower-right corner of a border of a resizable window (the user can click the mouse to resize the window diagonally).
		Switch $hWnd
			Case $g_hMainGUI, $g_hChildGUI
				Local $aPos, $iWin
				_FileReadToArray($g_sWindowIni, $aPos, $FRTA_NOCOUNT, '|')
				If @error Then Exit 999
;~ 				_ArrayDisplay($aPos, '$aPos')
				$iWin = $hWnd = $g_hMainGUI ? 0 : 1
				ConsoleWrite(StringFormat('_WM_NCLBUTTONDBLCLK: %-8s: %5i, %5i, %5i, %5i', $iWin ? 'ChildGUI' : ' MainGUI', $aPos[$iWin][1], $aPos[$iWin][2], $aPos[$iWin][3], $aPos[$iWin][4]) & @CRLF)
;~ 				WinMove($hWnd, '', $aPos[$iWin][1], $aPos[$iWin][2], $aPos[$iWin][3], $aPos[$iWin][4])
				Local $tRECT = _WinAPI_CreateRectEx($aPos[$iWin][1], $aPos[$iWin][2], $aPos[$iWin][3], $aPos[$iWin][4])
				Local $tWINDOWPLACEMENT = _WinAPI_GetWindowPlacement($hWnd)
				DllStructSetData($tWINDOWPLACEMENT, 'rcNormalPosition', DllStructGetData($tRECT, 'Left'), 1)
				DllStructSetData($tWINDOWPLACEMENT, 'rcNormalPosition', DllStructGetData($tRECT, 'Top'), 2)
				DllStructSetData($tWINDOWPLACEMENT, 'rcNormalPosition', DllStructGetData($tRECT, 'Right'), 3)
				DllStructSetData($tWINDOWPLACEMENT, 'rcNormalPosition', DllStructGetData($tRECT, 'Bottom'), 4)
				_WinAPI_SetWindowPlacement($hWnd, $tWINDOWPLACEMENT)
		EndSwitch
	EndIf

	; Standardmäßig wird der interne Message-Handler von AutoIt (falls es einen für diese Nachricht gibt) ausgeführt, nachdem die Benutzerfunktion beendet wurde.
	; Der interne Message-Handler von AutoIt wird ebenfalls ausgeführt, wenn das Schlüsselwort Return mit der Konstante $GUI_RUNDEFMSG (in GUIConstantsEx.au3) verwendet wird.
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NCLBUTTONDBLCLK

Func _WM_SIZE($hWnd, $iMsg, $wParam, $lParam)
	#forceref $iMsg, $wParam
	Local $iNewWidth = _WinAPI_LoWord($lParam) ; die neue Fensterbreite
;~ 	ConsoleWrite("> $iNewWidth                 --> " & $iNewWidth & @CRLF)
	Local $iNewHeight = _WinAPI_HiWord($lParam) ; die neue Fensterhöhe
	Local $iDiffX, $iDiffY
	Switch $hWnd
		Case $g_hMainGUI
			$iDiffX = $iNewWidth - $g_aClientSize[0]
			$iDiffY = $iNewHeight - $g_aClientSize[1]

;~ 			ConsoleWrite("> $iDiffX                    --> " & $iDiffX & @CRLF)
			Local $aHeaderClientSize = WinGetClientSize($g_hHeader)
			WinMove($g_hHeader, '', Default, Default, $iNewWidth, $aHeaderClientSize[1])

			Local $iItemCount = _GUICtrlHeader_GetItemCount($g_hHeader), $iItemWidth, $iAdd = $iDiffX / $iItemCount
;~ 			ConsoleWrite("> $iAdd                      --> " & $iAdd & @CRLF)

			Local $iWidth
			For $i = 0 To $iItemCount - 1 Step 1
				$iItemWidth = _GUICtrlHeader_GetItemWidth($g_hHeader, $i)
;~ 				ConsoleWrite("+ $iItemWidth                --> " & $iItemWidth & @CRLF)
				$iItemWidth = $iItemWidth + $iAdd
;~ 				ConsoleWrite("- $iItemWidth                --> " & $iItemWidth & @CRLF)
				If $i = $iItemCount - 1 Then
					If $iWidth <> $iNewWidth Then
						$iItemWidth += $iNewWidth - $iWidth
					EndIf
				EndIf
				$iWidth += $iItemWidth
;~ 				ConsoleWrite("! $iWidth                    --> " & $iWidth & @CRLF)
				_GUICtrlHeader_SetItemWidth($g_hHeader, $i, $iItemWidth)
			Next

;~ 			$g_aWinPos = WinGetPos($g_hMainGUI)
;~ 			$g_aClientSize = WinGetClientSize($g_hMainGUI)
;~ 			ConsoleWrite("- $g_aWinPos                 --> " & _ArrayToString($g_aWinPos, ', ') & @CRLF)
;~ 			ConsoleWrite("- $g_aClientSize             --> " & _ArrayToString($g_aClientSize, ', ') & @CRLF)
;~ 			ConsoleWrite("- $iWidth                    --> " & $iWidth & @CRLF)

			_GUICtrlStatusBar_Resize($g_hStatus)
;~ 			_WinAPI_RedrawWindow($g_hMainGUI)
		Case $g_hChildGUI
			_GUICtrlStatusBar_Resize($g_hChildStatus)
;~ 			_WinAPI_RedrawWindow($g_hMainGUI)
	EndSwitch

	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_SIZE

Func _WM_GETMINMAXINFO($hWnd, $iMsg, $wParam, $lParam)
	#forceref $iMsg, $wParam ; eine Anweisung an AutoIt, dass diese Variablen hier nicht verwendet werden
;~ 	Local $iXmin, $iYmin, $MINMAXINFO = DllStructCreate('int;int;int;int;int;int;int;int;int;int', $lParam) ; Struktur erstellen
;~ 	Local $iMaxPosX, $iMaxPosY, $iXmin, $iYmin
	Local $iXmin, $iYmin
	;                                 1                 2                 3                4                5                    6                    7                     8                     9                     10
	Local $MINMAXINFO = DllStructCreate("struct; long ptReserved_X;long ptReserved_Y;long ptMaxSize_X;long ptMaxSize_Y;long ptMaxPosition_X;long ptMaxPosition_Y;long ptMinTrackSize_X;long ptMinTrackSize_Y;long ptMaxTrackSize_X;long ptMaxTrackSize_Y;endstruct", $lParam) ; Struktur erstellen

;~ 	$iMaxPosX = DllStructGetData($MINMAXINFO, 'ptMaxPosition_X')
;~ 	$iMaxPosY = DllStructGetData($MINMAXINFO, 'ptMaxPosition_Y')

	Switch $hWnd
		Case $g_hMainGUI
			; Mindestgröße für das Hauptfenster festlegen
			$iXmin = $g_iMainGUIWidthMin ; + 2 * _WinAPI_GetSystemMetrics($SM_CXFRAME) ; min X = Breite aller ListView-Spalten + 2 * Fensterrahmen
			$iYmin = $g_iMainGUIHeightMin ; + 2 * _WinAPI_GetSystemMetrics($SM_CYFRAME) ; min Y = 480 + 2 * Fensterrahmen
;~ 			$iYmin += _WinAPI_GetSystemMetrics($SM_CYCAPTION) ; min Y += Titelleiste
;~ 			$iYmin += _WinAPI_GetSystemMetrics($SM_CYMENUSIZE) ; min Y += Menueleiste
;~ 			DllStructSetData($MINMAXINFO, 7, $iXmin) ; Mindestbreite festlegen
;~ 			DllStructSetData($MINMAXINFO, 8, $iYmin) ; Mindesthöhe festlegen
			DllStructSetData($MINMAXINFO, 'ptMinTrackSize_X', $iXmin) ; Mindestbreite festlegen
			DllStructSetData($MINMAXINFO, 'ptMinTrackSize_Y', $iYmin) ; Mindesthöhe festlegen
			; Position für das Hauptfenster festlegen
;~ 			Select
;~ 				Case $iMaxPosX <
;~ 				Case $iMaxPosX >
;~ 				Case $iMaxPosY <
;~ 				Case $iMaxPosY >
;~ 			EndSelect
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_GETMINMAXINFO
